{{
  74HCT595 Object for controlling 7-Seg LED
  MJZ
}}

CON
' %00000010 : TOP
' %00000100 : RTOP
' %00001000 : RBOT
' %00010000 : BOT
' %00100000 : LBOT
' %01000000 : LTOP
' %10000000 : MID
  DISP_1 = %00001100
  DISP_2 = %10110110
  DISP_3 = %10011110
  DISP_4 = %11001100
  DISP_5 = %11011010
  DISP_6 = %11111010
  DISP_7 = %00001110
  DISP_8 = %11111110
  DISP_9 = %11011110
  DISP_0 = %01111110


VAR
  byte                bytePattern
  
OBJ
  IO            : "ShiftIO"
  TIME          : "Timing"

PUB SetValue (pinData, pinClock, pinLatch, lNumber)

  bytePattern := %00000000
  'Figure out what pattern to use
  case lNumber
    1: bytePattern := DISP_1
    2: bytePattern := DISP_2
    3: bytePattern := DISP_3
    4: bytePattern := DISP_4
    5: bytePattern := DISP_5
    6: bytePattern := DISP_6
    7: bytePattern := DISP_7
    8: bytePattern := DISP_8
    9: bytePattern := DISP_9
    0: bytePattern := DISP_0

  'Set the pins to output and put low
  dira [pinLatch] := 1
  outa [pinLatch] := 0

  'Shift out the data
  IO.shiftout (pinData, pinClock, IO#MsbFirst, bytePattern, 8)
  '10uS
  outa [pinLatch] := 1
  TIME.pause10us (11)
  outa [pinLatch] := 0